# Annotation Type IosPrivacy

@Retention(CLASS) @Target(TYPE) public @interface IosPrivacy

iOS `Info.plist` privacy usage descriptions. Set the one for every protected resource your app touches: the build server accepts an app without them, and the App Store rejects it.

Place this on your application's main class -- the class named by `codename1.mainName`. An attribute you do not set is not written at all, so the builder's own default applies; the values shown here are that default, for reference.

Generated from com.codename1.build.shared.BuildHints by BuildHintCodeGenerator. Do not edit by hand -- edit the catalog and re-run scripts/gen-build-hint-annotations.sh.

- ## Optional Element Summary

  Optional Elements
  Modifier and Type
  Optional Element
  Description
  `String`
  `calendarsFullAccessUsageDescription`
  The text iOS shows when the app first asks for the calendars full access.
  `String`
  `calendarsUsageDescription`
  The text iOS shows when the app first asks for the calendars.
  `String`
  `calendarsWriteOnlyAccessUsageDescription`
  The text iOS shows when the app first asks for the calendars write only access.
  `String`
  `cameraUsageDescription`
  The text iOS shows when the app first asks for the camera.
  `String`
  `healthShareUsageDescription`
  The text iOS shows when the app first asks for the health share.
  `String`
  `healthUpdateUsageDescription`
  The text iOS shows when the app first asks for the health update.
  `String`
  `localNetworkUsageDescription`
  The text iOS shows when the app first asks for the local network.
  `String`
  `locationAlwaysAndWhenInUseUsageDescription`
  The text iOS shows when the app first asks for the location always and when in use.
  `String`
  `locationAlwaysUsageDescription`
  The text iOS shows when the app first asks for the location always.
  `String`
  `locationWhenInUseUsageDescription`
  The text iOS shows when the app first asks for the location when in use.
  `String`
  `microphoneUsageDescription`
  The text iOS shows when the app first asks for the microphone.
  `String`
  `remindersFullAccessUsageDescription`
  The text iOS shows when the app first asks for the reminders full access.
  `String`
  `remindersUsageDescription`
  The text iOS shows when the app first asks for the reminders.

- ## Element Details

  - ### calendarsFullAccessUsageDescription

    String calendarsFullAccessUsageDescription
    The text iOS shows when the app first asks for the calendars full access. It becomes the `NSCalendarsFullAccessUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `"This app uses your calendars to read and schedule events."`

  - ### calendarsUsageDescription

    String calendarsUsageDescription
    The text iOS shows when the app first asks for the calendars. It becomes the `NSCalendarsUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### calendarsWriteOnlyAccessUsageDescription

    String calendarsWriteOnlyAccessUsageDescription
    The text iOS shows when the app first asks for the calendars write only access. It becomes the `NSCalendarsWriteOnlyAccessUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `"This app uses your calendar to schedule events."`

  - ### cameraUsageDescription

    String cameraUsageDescription
    The text iOS shows when the app first asks for the camera. It becomes the `NSCameraUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### healthShareUsageDescription

    String healthShareUsageDescription
    The text iOS shows when the app first asks for the health share. It becomes the `NSHealthShareUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### healthUpdateUsageDescription

    String healthUpdateUsageDescription
    The text iOS shows when the app first asks for the health update. It becomes the `NSHealthUpdateUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### localNetworkUsageDescription

    String localNetworkUsageDescription
    The text iOS shows when the app first asks for the local network. It becomes the `NSLocalNetworkUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### locationAlwaysAndWhenInUseUsageDescription

    String locationAlwaysAndWhenInUseUsageDescription
    The text iOS shows when the app first asks for the location always and when in use. It becomes the `NSLocationAlwaysAndWhenInUseUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### locationAlwaysUsageDescription

    String locationAlwaysUsageDescription
    The text iOS shows when the app first asks for the location always. It becomes the `NSLocationAlwaysUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### locationWhenInUseUsageDescription

    String locationWhenInUseUsageDescription
    The text iOS shows when the app first asks for the location when in use. It becomes the `NSLocationWhenInUseUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### microphoneUsageDescription

    String microphoneUsageDescription
    The text iOS shows when the app first asks for the microphone. It becomes the `NSMicrophoneUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`

  - ### remindersFullAccessUsageDescription

    String remindersFullAccessUsageDescription
    The text iOS shows when the app first asks for the reminders full access. It becomes the `NSRemindersFullAccessUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `"This app uses your reminders to read and schedule tasks."`

  - ### remindersUsageDescription

    String remindersUsageDescription
    The text iOS shows when the app first asks for the reminders. It becomes the `NSRemindersUsageDescription` key in `Info.plist`. The App Store rejects an app that touches this resource without one.
    Default:
      `""`